/**
 * @file
 * Author: Synapse-studio.
 */

(function ($) {
  $(document).ready(function () {

    // Map stuff.
    ymaps.ready(ymapsInit);

    function ymapsInit() {
      $('#edit-geo').after('<div id="map-picker" style="min-height:300px"></div>');

      // MAP create.
      var mapSet = drupalSettings.synmap.data;
      var map = new ymaps.Map('map-picker', {
        center: [mapSet.longitude, mapSet.latitude],
        zoom: mapSet.zoom,
        controls: ['zoomControl', 'fullscreenControl']
      });
      var searchControl = new ymaps.control.SearchControl({
        options: {
          provider: 'yandex#search'
        }
      });
      map.controls.add(searchControl);
      map.behaviors.disable('scrollZoom');

      // Point options.
      var defaultParams = {
        geometry: {
          type: 'Point',
          coordinates: [mapSet.longitude, mapSet.latitude]
        },
        properties: {
          iconContent: mapSet.name
        }
      };
      var defaultPreset = {
        preset: 'islands#blackStretchyIcon',
        draggable: true
      };

      // Add default point.
      var companyPlacemark = new ymaps.GeoObject(defaultParams, defaultPreset);
      map.geoObjects.add(companyPlacemark);
      map.geoObjects.events.add('dragend', function (e) {
        var coords = companyPlacemark.geometry.getCoordinates();
        $(mapSet.editlatitude).attr('value', coords[1]);
        $(mapSet.editlongitude).attr('value', coords[0]);
      });

      // Change point on click.
      map.events.add('click', function (e) {
        map.geoObjects.removeAll();

        var newParams = defaultParams;
        newParams.geometry.coordinates = e.get('coords');
        var companyPlacemark = new ymaps.GeoObject(newParams, defaultPreset);
        map.geoObjects.add(companyPlacemark);

        var coords = e.get('coords');
        // console.log(coords[0]); //.
        $(mapSet.editlatitude).attr('value', coords[1]);
        $(mapSet.editlongitude).attr('value', coords[0]);
      });
    }
  });
})(this.jQuery);
